;
; make Barotropic Stream Function
;
FUNCTION make_bsf, file_name, ncdf_db,  TIME_1 = time_1,  TIME_2 =  time_2, ZMTYP = zmtyp

@common
@com_eg
;
;
; Read taux and tauy
;
; HISTORY:
;
;       Fri Apr 6 12:18:15 2001, Eric Guilyardi
;       <ericg@lemnos.rdg.ac.uk>
;
;		
;
   file_nam = strmid(file_name, 0, strlen(file_name)-4)
; keep current settings
;   old_boite = [lon1, lon2, lat1, lat2, prof1, prof2]
;   domdef
; diag_bsf requires the whole domain
   jpi = 182
   jpj = 149
   key_offset = [0, 0, 0]
   key_shift_old = key_shift
   key_shift = 0
   ixminmesh  =0
   ixmaxmesh  =181
;
   iyminmesh  =0
   iymaxmesh  =148
   
   CASE config OF
      'ORCA_R2': BEGIN
         ncdf_meshlec, 'meshmask.orca.2d.nc' ; for ST7-type runs
;        ncdf_meshlec, 'meshmask_ORCA_R2.nc' ; for CT/TT-type runs
      END 
      'ORCA_R4': BEGIN 
         ncdf_meshlec, 'meshmask_orca4.nc' 
      END 
   ENDCASE 
; make masks
   umaskr = umask()
   vmaskr = vmask()
   fmaskr = fmask()

   vargrid = 'U'
   u = nc_read(file_nam+'U.nc','vozocrtx', ncdf_db,  TIME_1 = time_1,  TIME_2 =  time_2, /ALL_DATA)
   vargrid = 'V'
   v = nc_read(file_nam+'V.nc','vomecrty', ncdf_db,  TIME_1 = time_1,  TIME_2 =  time_2, /ALL_DATA)

   IF time_1 EQ time_2 THEN BEGIN 

      bsf = diag_bsf(u.data, v.data)
      bsfr = bsf[1:jpi-2, 0:jpj-2]
      bsfr = shift(bsfr, key_shift_old, 0)
   
   ENDIF ELSE BEGIN
      
      jpt = time_2-time_1+1
      bsfr = fltarr(180, 148, jpt)
      FOR t = 0, jpt DO BEGIN 

         bsf= diag_bsf(u.data(*, *, *, t), v.data(*, *, *, t))
         bsft = bsf[1:jpi-2, 0:jpj-2]
         bsfr(*, *, t) = shift(bsft, key_shift_old, 0)
      ENDFOR 

   ENDELSE 

; extract sub-domain
   

   jpi = 180
   jpj = 148
   key_offset = [2, 0, 0]
   key_shift = key_shift_old
   ixminmesh  =2
   ixmaxmesh  =181
;
   iyminmesh  =0
   iymaxmesh  =147
;
   izminmesh  =0
   izmaxmesh  =30
   key_periodique = 1
   ncdf_meshlec, 'meshmask_ORCA_R2.nc' 

   isign=where(glamt gt 380.)
   IF isign(0) NE -1 THEN glamt(isign) = glamt(isign)-360.
   isign=where(glamu gt 380.)
   IF isign(0) NE -1 THEN glamu(isign) = glamu(isign)-360.
   isign=where(glamv gt 380.)
   IF isign(0) NE -1 THEN glamv(isign) = glamv(isign)-360.
   isign=where(glamf gt 380.)
   IF isign(0) NE -1 THEN glamf(isign) = glamf(isign)-360.
;   domdef, old_boite

   field = {name: '', data: bsfr, legend: '', units: '', origin: '', dim: 0}
   
   field.origin = u.origin
   field.dim = u.dim

   return, field
END 
