;
; make std dev from 2D macro_base_fld monthly time serie (defined in macro_read)
;
FUNCTION make_stddev, file_name, ncdf_db,  TIME_1 = time_1,  TIME_2 =  time_2, ALL_DATA = all_data, ZMTYP = zmtyp

@common
@com_eg
;
;
; Read time serie
;
   IF debug_w THEN print, 'keyword_set(ALL_DATA) : ', keyword_set(ALL_DATA) 

   mfld = nc_read(file_name, macro_base_fld, ncdf_db,  TIME_1 = time_1,  TIME_2 =  time_2, ALL_DATA = all_data)

   mfld.data = trends(mfld.data, '412', 'xyt')

   print, '    Warning: standard deviation assuming monthly time serie of base field ',macro_base_fld 

; Modif MK

   IF stddev_mth NE '00' THEN BEGIN

      mth = ['Jan',  'Feb',  'Mar',  'Apr',  'May',  'Jun',  'Jul',  'Aug', 'Sep',  'Oct', 'Nov',  'Dec']
      CASE STRMID(stddev_mth, 0, 2) OF
         '01': strd = 1
         '02': strd = 2
         '03': strd = 3
         '04': strd = 4
         '05': strd = 5
         '06': strd = 6
         '07': strd = 7
         '08': strd = 8
         '09': strd = 9
         '10': strd = 10
         '11': strd = 11
         '12': strd = 12
         ENDCASE

     print,  '    Warning: standard deviation computed for ', mth[strd-1] 

; Sampling of data and computation of new numbers of values
      data =  (mfld.data)[*, *, strd-1:*:12]        
      nval =  (size(data))[3]
   ENDIF ELSE BEGIN
      data =  mfld.data
      nval =  jpt
   ENDELSE

   std = a_timecorrelate(data, 0,/covariance)
   std = sqrt( nval/(nval-1)*std )
   idx =  WHERE (std GT 1.0e+10)

   IF idx(0) NE -1 THEN std(idx) = valmask

   IF stddev_mth NE '00' AND stddev_diff EQ 1 THEN BEGIN
      print,  ' Warning: standard deviation diff between ', mth[strd-1],  ' and the whole serie'
      std_tot = a_timecorrelate(mfld.data, 0,/covariance)
      std_tot = sqrt( jpt/(jpt-1)*std_tot )
      IF idx(0) NE -1 THEN std_tot(idx) = valmask
      idx_diff =  WHERE (std NE valmask)
      std(idx_diff) =  std(idx_diff) - std_tot(idx_diff)
   ENDIF

   field = {name: '', data: std, legend: '', units: '', origin: '', dim: 0, direc:''}
   
   field.origin = mfld.origin
   
   field.dim = 2
   
   IF stddev_mth NE '00' THEN BEGIN
      field.legend = ' for '+mth[strd-1]+' in ['+cmdm.date1+' - '+cmdm.spec+'] - '
      IF stddev_diff EQ 1 THEN BEGIN
         field.legend = ' diff between '+mth[strd-1]+' and total TS ['+cmdm.date1+' - '+cmdm.spec+'] - '       
      ENDIF
   ENDIF ELSE BEGIN
      field.legend = ' ['+cmdm.date1+' - '+cmdm.spec+']'
   ENDELSE

; Fin Modif MK

;  data and plot are 2D

   field.direc = 'xy'

   return, field
END 
